Loading...
Searching...
No Matches
juce::AudioFormatReader Class Referenceabstract

## Detailed Description

Reads samples from an audio file stream.

A subclass that reads a specific type of audio format will be created by an AudioFormat object.

See also
  AudioFormat, AudioFormatWriter

The documentation for this class was generated from the following file:

- juce_audio_formats/format/juce_AudioFormatReader.h

Inheritance diagram for juce::AudioFormatReader:

## Classes

struct | ReadHelper
| Used by AudioFormatReader subclasses to copy data to different formats. More...

## Public Member Functions

virtual | ~AudioFormatReader ()
| Destructor.
const String & | getFormatName () const noexcept
| Returns a description of what type of format this is.
bool | read (float *const *destChannels, int numDestChannels, int64 startSampleInSource, int numSamplesToRead)
| Reads samples from the stream.
bool | read (int *const *destChannels, int numDestChannels, int64 startSampleInSource, int numSamplesToRead, bool fillLeftoverChannelsWithCopies)
| Reads samples from the stream.
bool | read (AudioBuffer< float > *buffer, int startSampleInDestBuffer, int numSamples, int64 readerStartSample, bool useReaderLeftChan, bool useReaderRightChan)
| Fills a section of an AudioBuffer from this reader.
virtual void | readMaxLevels (int64 startSample, int64 numSamples, Range< float > *results, int numChannelsToRead)
| Finds the highest and lowest sample levels from a section of the audio stream.
virtual void | readMaxLevels (int64 startSample, int64 numSamples, float &lowestLeft, float &highestLeft, float &lowestRight, float &highestRight)
| Finds the highest and lowest sample levels from a section of the audio stream.
int64 | searchForLevel (int64 startSample, int64 numSamplesToSearch, double magnitudeRangeMinimum, double magnitudeRangeMaximum, int minimumConsecutiveSamples)
| Scans the source looking for a sample whose magnitude is in a specified range.
virtual AudioChannelSet | getChannelLayout ()
| Get the channel layout of the audio stream.
virtual bool | readSamples (int *const *destChannels, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int numSamples)=0
| Subclasses must implement this method to perform the low-level read operation.

## Public Attributes

double | sampleRate = 0
| The sample-rate of the stream.
unsigned int | bitsPerSample = 0
| The number of bits per sample, e.g.
int64 | lengthInSamples = 0
| The total number of samples in the audio stream.
unsigned int | numChannels = 0
| The total number of channels in the audio stream.
bool | usesFloatingPointData = false
| Indicates whether the data is floating-point or fixed.
StringPairArray | metadataValues
| A set of metadata values that the reader has pulled out of the stream.
InputStream * | input
| The input stream, for use by subclasses.

## Protected Member Functions

| AudioFormatReader (InputStream *sourceStream, const String &formatName)
| Creates an AudioFormatReader object.

## Static Protected Member Functions

static void | clearSamplesBeyondAvailableLength (int *const *destChannels, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int &numSamples, int64 fileLengthInSamples)
| Used by AudioFormatReader subclasses to clear any parts of the data blocks that lie beyond the end of their available length.

## Constructors and Destructors

## AudioFormatReader()

juce::AudioFormatReader::AudioFormatReader | ( | InputStream * | sourceStream,
|  | const String & | formatName )

protected

Creates an AudioFormatReader object.

Parameters

  sourceStream | the stream to read from - this will be deleted by this object when it is no longer needed. (Some specialised readers might not use this parameter and can leave it as nullptr).
  formatName | the description that will be returned by the getFormatName() method

Referenced by juce::AudioSubsectionReader::AudioSubsectionReader(), juce::BufferingAudioReader::BufferingAudioReader(), juce::MemoryMappedAudioFormatReader::MemoryMappedAudioFormatReader(), juce::AudioSubsectionReader::readMaxLevels(), and juce::BufferingAudioReader::readSamples().

## ~AudioFormatReader()

virtual juce::AudioFormatReader::~AudioFormatReader | ( |  | ) |

virtual

Destructor.

## Member Functions

## getFormatName()

const String & juce::AudioFormatReader::getFormatName | ( |  | ) | const

inline noexcept

Returns a description of what type of format this is.

E.g. "AIFF"

## read() [1/3]

bool juce::AudioFormatReader::read | ( | float *const * | destChannels,
|  | int | numDestChannels,
|  | int64 | startSampleInSource,
|  | int | numSamplesToRead )

Reads samples from the stream.

Parameters

  destChannels | an array of float buffers into which the sample data for each channel will be written. Channels that aren't needed can be null
  numDestChannels | the number of array elements in the destChannels array
  startSampleInSource | the position in the audio file or stream at which the samples should be read, as a number of samples from the start of the stream. It's ok for this to be beyond the start or end of the available data - any samples that are out-of-range will be returned as zeros.
  numSamplesToRead | the number of samples to read. If this is greater than the number of samples that the file or stream contains. the result will be padded with zeros

Returns
  true if the operation succeeded, false if there was an error. Note that reading sections of data beyond the extent of the stream isn't an error - the reader should just return zeros for these regions

See also
  readMaxLevels

## read() [2/3]

bool juce::AudioFormatReader::read | ( | int *const * | destChannels,
|  | int | numDestChannels,
|  | int64 | startSampleInSource,
|  | int | numSamplesToRead,
|  | bool | fillLeftoverChannelsWithCopies )

Reads samples from the stream.

Parameters

  destChannels

  an array of buffers into which the sample data for each channel will be written. If the format is fixed-point, each channel will be written as an array of 32-bit signed integers using the full range -0x80000000 to 0x7fffffff, regardless of the source's bit-depth. If it is a floating-point format, you should cast the resulting array to a (float**) to get the values (in the range -1.0 to 1.0 or beyond) If the format is stereo, then destChannels[0] is the left channel data, and destChannels[1] is the right channel. The numDestChannels parameter indicates how many pointers this array contains, but some of these pointers can be null if you don't want to read data for some of the channels

  numDestChannels | the number of array elements in the destChannels array
  startSampleInSource | the position in the audio file or stream at which the samples should be read, as a number of samples from the start of the stream. It's ok for this to be beyond the start or end of the available data - any samples that are out-of-range will be returned as zeros.
  numSamplesToRead | the number of samples to read. If this is greater than the number of samples that the file or stream contains. the result will be padded with zeros

  fillLeftoverChannelsWithCopies

  if true, this indicates that if there's no source data available for some of the channels that you pass in, then they should be filled with copies of valid source channels. E.g. if you're reading a mono file and you pass 2 channels to this method, then if fillLeftoverChannelsWithCopies is true, both destination channels will be filled with the same data from the file's single channel. If fillLeftoverChannelsWithCopies was false, then only the first channel would be filled with the file's contents, and the second would be cleared. If there are many channels, e.g. you try to read 4 channels from a stereo file, then the last 3 would all end up with copies of the same data.

Returns
  true if the operation succeeded, false if there was an error. Note that reading sections of data beyond the extent of the stream isn't an error - the reader should just return zeros for these regions

See also
  readMaxLevels

## read() [3/3]

bool juce::AudioFormatReader::read | ( | AudioBuffer< float > * | buffer,
|  | int | startSampleInDestBuffer,
|  | int | numSamples,
|  | int64 | readerStartSample,
|  | bool | useReaderLeftChan,
|  | bool | useReaderRightChan )

Fills a section of an AudioBuffer from this reader.

This will convert the reader's fixed- or floating-point data to the buffer's floating-point format, and will try to intelligently cope with mismatches between the number of channels in the reader and the buffer.

Returns
  true if the operation succeeded, false if there was an error. Note that reading sections of data beyond the extent of the stream isn't an error - the reader should just return zeros for these regions

## readMaxLevels() [1/2]

virtual void juce::AudioFormatReader::readMaxLevels | ( | int64 | startSample,
|  | int64 | numSamples,
|  | Range< float > * | results,
|  | int | numChannelsToRead )

virtual

Finds the highest and lowest sample levels from a section of the audio stream.

This will read a block of samples from the stream, and measure the highest and lowest sample levels from the channels in that section, returning these as normalised floating-point levels.

Parameters

  startSample | the offset into the audio stream to start reading from. It's ok for this to be beyond the start or end of the stream.
  numSamples | how many samples to read
  results | this array will be filled with Range values for each channel. The array must contain numChannels elements.
  numChannelsToRead | the number of channels of data to scan. This must be more than zero, but not more than the total number of channels that the reader contains

See also
  read

Reimplemented in juce::AudioSubsectionReader.

Referenced by juce::AudioSubsectionReader::readMaxLevels().

## readMaxLevels() [2/2]

virtual void juce::AudioFormatReader::readMaxLevels | ( | int64 | startSample,
|  | int64 | numSamples,
|  | float & | lowestLeft,
|  | float & | highestLeft,
|  | float & | lowestRight,
|  | float & | highestRight )

virtual

Finds the highest and lowest sample levels from a section of the audio stream.

This will read a block of samples from the stream, and measure the highest and lowest sample levels from the channels in that section, returning these as normalised floating-point levels.

Parameters

  startSample | the offset into the audio stream to start reading from. It's ok for this to be beyond the start or end of the stream.
  numSamples | how many samples to read
  lowestLeft | on return, this is the lowest absolute sample from the left channel
  highestLeft | on return, this is the highest absolute sample from the left channel
  lowestRight | on return, this is the lowest absolute sample from the right channel (if there is one)
  highestRight | on return, this is the highest absolute sample from the right channel (if there is one)

See also
  read

Reimplemented in juce::AudioSubsectionReader.

## searchForLevel()

int64 juce::AudioFormatReader::searchForLevel | ( | int64 | startSample,
|  | int64 | numSamplesToSearch,
|  | double | magnitudeRangeMinimum,
|  | double | magnitudeRangeMaximum,
|  | int | minimumConsecutiveSamples )

Scans the source looking for a sample whose magnitude is in a specified range.

This will read from the source, either forwards or backwards between two sample positions, until it finds a sample whose magnitude lies between two specified levels.

If it finds a suitable sample, it returns its position; if not, it will return -1.

There's also a minimumConsecutiveSamples setting to help avoid spikes or zero-crossing points when you're searching for a continuous range of samples

Parameters

  startSample | the first sample to look at
  numSamplesToSearch | the number of samples to scan. If this value is negative, the search will go backwards
  magnitudeRangeMinimum | the lowest magnitude (inclusive) that is considered a hit, from 0 to 1.0
  magnitudeRangeMaximum | the highest magnitude (inclusive) that is considered a hit, from 0 to 1.0
  minimumConsecutiveSamples | if this is > 0, the method will only look for a sequence of this many consecutive samples, all of which lie within the target range. When it finds such a sequence, it returns the position of the first in-range sample it found (i.e. the earliest one if scanning forwards, the latest one if scanning backwards)

## getChannelLayout()

virtual AudioChannelSet juce::AudioFormatReader::getChannelLayout | ( |  | ) |

virtual

Get the channel layout of the audio stream.

## readSamples()

virtual bool juce::AudioFormatReader::readSamples | ( | int *const * | destChannels,
|  | int | numDestChannels,
|  | int | startOffsetInDestBuffer,
|  | int64 | startSampleInFile,
|  | int | numSamples )

pure virtual

Subclasses must implement this method to perform the low-level read operation.

Callers should use read() instead of calling this directly.

Parameters

  destChannels | the array of destination buffers to fill. Some of these pointers may be null
  numDestChannels | the number of items in the destChannels array. This value is guaranteed not to be greater than the number of channels that this reader object contains
  startOffsetInDestBuffer | the number of samples from the start of the dest data at which to begin writing
  startSampleInFile | the number of samples into the source data at which to begin reading. This value is guaranteed to be >= 0.
  numSamples | the number of samples to read

Implemented in juce::ARAAudioSourceReader, juce::ARAPlaybackRegionReader, juce::AudioCDReader, juce::AudioSubsectionReader, and juce::BufferingAudioReader.

## clearSamplesBeyondAvailableLength()

void juce::AudioFormatReader::clearSamplesBeyondAvailableLength | ( | int *const * | destChannels,
|  | int | numDestChannels,
|  | int | startOffsetInDestBuffer,
|  | int64 | startSampleInFile,
|  | int & | numSamples,
|  | int64 | fileLengthInSamples )

inline static protected

Used by AudioFormatReader subclasses to clear any parts of the data blocks that lie beyond the end of their available length.

References jassertfalse, and juce::zeromem().

## Member Data Documentation

## sampleRate

double juce::AudioFormatReader::sampleRate = 0

The sample-rate of the stream.

Referenced by juce::ARAPlaybackRegionReader::ARAPlaybackRegionReader().

## bitsPerSample

unsigned int juce::AudioFormatReader::bitsPerSample = 0

The number of bits per sample, e.g.

16, 24, 32.

Referenced by juce::MemoryMappedAudioFormatReader::scanMinAndMaxInterleaved().

## lengthInSamples

int64 juce::AudioFormatReader::lengthInSamples = 0

The total number of samples in the audio stream.

## numChannels

unsigned int juce::AudioFormatReader::numChannels = 0

The total number of channels in the audio stream.

Referenced by juce::ARAPlaybackRegionReader::ARAPlaybackRegionReader(), and juce::MemoryMappedAudioFormatReader::scanMinAndMaxInterleaved().

## usesFloatingPointData

bool juce::AudioFormatReader::usesFloatingPointData = false

Indicates whether the data is floating-point or fixed.

## metadataValues

StringPairArray juce::AudioFormatReader::metadataValues

A set of metadata values that the reader has pulled out of the stream.

Exactly what these values are depends on the format, so you can check out the format implementation code to see what kind of stuff they understand.

## input

InputStream* juce::AudioFormatReader::input

The input stream, for use by subclasses.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited